<template>
  <q-layout view="lhr LpR lfr">

    <q-header reveal elevated class="bg-primary text-white">
      <q-toolbar>
        <q-btn dense flat round icon="menu" @click="left = !left" />

        <q-toolbar-title>
          <q-avatar>
            <img src="https://cdn.quasar.dev/logo/svg/quasar-logo.svg">
          </q-avatar>
          Dev. Env.
        </q-toolbar-title>

        <q-btn dense flat round icon="menu" @click="right = !right" />
      </q-toolbar>
    </q-header>

    <q-drawer show-if-above v-model="left" side="left" elevated>
      <!-- drawer content -->
      <q-list>

        <q-item-label
          header
          class="text-grey-8"
        >
          Your Project(s) list
        </q-item-label>

        <q-item 
          clickable v-ripple
          @click="newProjDiag()"
        >
          <q-item-section>New Project</q-item-section>
        </q-item>

        <q-item 
          clickable v-ripple
          to="/"
        >
          <q-item-section>Back Main Page</q-item-section>
        </q-item>

        <q-separator />

        <q-item 
          clickable v-ripple
          v-for="proj in getProjs"
          @click="goSelProj(proj)"
        >
          <q-item-section>{{proj.projName}}</q-item-section>
        </q-item>

      </q-list>
    </q-drawer>

    <q-drawer show-if-above v-model="right" side="right" elevated>
      <!-- drawer content -->
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>

    <q-dialog v-model="carousel">
      <q-carousel
        transition-prev="slide-right"
        transition-next="slide-left"
        swipeable
        animated
        v-model="slide"
        control-color="primary"
        navigation-icon="radio_button_unchecked"
        navigation
        padding
        height="600px"
        class="bg-white shadow-1 rounded-borders"
      >

        <q-carousel-slide :name="1" class="column no-wrap flex-center">

          <div class="row no-wrap items-center">
            <div class="col text-h6 ellipsis">
              Select a Solution
            </div>
          </div>

          <div class="q-pa-md" style="max-width: 600px">
              <q-card>
                <q-tabs
                  v-model="tab"
                  dense
                  class="text-grey"
                  active-color="primary"
                  indicator-color="primary"
                  align="justify"
                >
                  <q-tab name="frontend" label="Frontend" />
                  <q-tab name="alarms" label="not yet #1" />
                  <q-tab name="movies" label="not yet #2" />
                </q-tabs>

                <q-separator />

                <q-tab-panels v-model="tab" animated>
                  <q-tab-panel name="frontend" class="q-pa-none">

                    <q-splitter
                      v-model="splitterModel"
                      style="height: 250px"
                    >

                      <template v-slot:before>
                        <q-tabs
                          v-model="innerTab"
                          vertical
                          class="text-teal"
                        >
                          <q-tab name="vueQuasar" icon="mail" label="Vue Quasar" />
                          <q-tab name="innerAlarms" icon="alarm" label="not yet #1" />
                          <q-tab name="innerMovies" icon="movie" label="not yet #2" />
                        </q-tabs>
                      </template>

                      <template v-slot:after>
                        <q-tab-panels
                          v-model="innerTab"
                          animated
                          transition-prev="slide-down"
                          transition-next="slide-up"
                        >
                          <q-tab-panel name="vueQuasar">
                            <div class="text-h4 q-mb-md">Vue Quasar</div>
                            <p>Quasar Frontend</p>
                            <q-radio v-model="solution" val="quasar" label="Quasar" />
                          </q-tab-panel>

                          <q-tab-panel name="innerAlarms">
                            <div class="text-h4 q-mb-md">Not Yet #1</div>
                            <p>Not Yet #1</p>
                            <q-radio v-model="solution" val="notyet1" label="Not Yet #1" />
                          </q-tab-panel>

                          <q-tab-panel name="innerMovies">
                            <div class="text-h4 q-mb-md">Movies</div>
                            <p>Lorem ipsum dolor sit, amet consectetur adipisicing elit. Quis praesentium cumque magnam odio iure quidem, quod illum numquam possimus obcaecati commodi minima assumenda consectetur culpa fuga nulla ullam. In, libero.</p>
                            <p>Lorem ipsum dolor sit, amet consectetur adipisicing elit. Quis praesentium cumque magnam odio iure quidem, quod illum numquam possimus obcaecati commodi minima assumenda consectetur culpa fuga nulla ullam. In, libero.</p>
                            <p>Lorem ipsum dolor sit, amet consectetur adipisicing elit. Quis praesentium cumque magnam odio iure quidem, quod illum numquam possimus obcaecati commodi minima assumenda consectetur culpa fuga nulla ullam. In, libero.</p>
                          </q-tab-panel>
                        </q-tab-panels>
                      </template>

                    </q-splitter>
                  </q-tab-panel>

                  <q-tab-panel name="alarms">
                    <div class="text-h6">Alarms</div>
                    Lorem ipsum dolor sit amet consectetur adipisicing elit.
                  </q-tab-panel>

                  <q-tab-panel name="movies">
                    <div class="text-h6">Movies</div>
                    Lorem ipsum dolor sit amet consectetur adipisicing elit.
                  </q-tab-panel>
                </q-tab-panels>
              </q-card>
            </div>

        </q-carousel-slide>

        <q-carousel-slide :name="2" class="column no-wrap flex-center">
          <q-icon name="live_tv" color="primary" size="56px" />
          <div class="q-mt-md text-center">
            <q-input standout="bg-teal text-white" v-model="projName" label="Project Name" />
          </div>
        </q-carousel-slide>

        <q-carousel-slide :name="3" class="column no-wrap flex-center">
          <q-icon name="live_tv" color="primary" size="56px" />
          <div class="q-mt-md text-center">
            <q-btn color="deep-orange" glossy label="Confirm to Create a New Project" @click="newProj()" />
          </div>
        </q-carousel-slide>

      </q-carousel>
    </q-dialog>

    <q-footer reveal elevated class="bg-grey-8 text-white">
      <q-toolbar>
        <q-toolbar-title>
          <q-avatar>
            <img src="https://cdn.quasar.dev/logo/svg/quasar-logo.svg">
          </q-avatar>
          {{loginName}}
        </q-toolbar-title>
      </q-toolbar>
    </q-footer>

  </q-layout>

</template>

<script>

// call to a msg dialog box
import { newMsgDiag } from 'src/utils/dialogs/dialogCreate'
import MsgDiaglog from "src/utils/dialogs/MsgDialog.vue"

export default {
  name: 'DevEnv',

  data () {
    return {
      left: false,
      right: false,
      loginName: this.$store.state.gen.userInfo.first_name,
      
      carousel: false,
      slide: 1,

      tab: 'mails',
      innerTab: 'innerMails',
      splitterModel: 20

      , solution: 'quasar'
      , projName: 't1'
    }
  },

  computed: {
    getProjs: function() {
      return this.$store.state.gen.projs;
    }
  },

  mounted () {
    var that = this;

    //==========================================
    // load the projects list

    if ( this.$store.state.gen.projs.length == 0 ) {
    //if ( true ) {

      // creating quasar dev. env.      
      this.$axios({
        url: 'gnl.gnl.doctype.devenv.devenv.listProj',
        method: 'post',
        baseURL: process.env.BACKEND_PROTO + process.env.BACKEND_DOMAIN + process.env.BACKEND_PORT + '/api/method/',
        data: {
          "user_id": this.$store.state.gen.userInfo.user_id
        },
        headers: { SfAuth: this.$store.state.gen.userInfo.token },
      })
      .then(function (response) {

        switch (response.status) {
            case 200:
                if (response.data == "{}") {
                    console.log('Creating Qusar: empty response data'); 
                } else {
                    var ret = JSON.parse(response.data.message);

                    if (ret.status == "Done") {

                        // clr the old array
                        that.$store.commit('gen/clrProjs');
                        
                        // loading existing proj.
                        for (var i = 0; i < ret.proj_names.length; i++) {
                          that.$store.commit('gen/addProj', ret.proj_names[i]);
                        }

                        // select a default proj. to display
                        //  default as 1st project
                        if (ret.proj_names.length != 0)
                          that.selProj(ret.proj_names[0]);

                    } else if (ret.status == "InAuth") {
                        //console.log("ret.des ", ret.des);
                        newMsgDiag(MsgDiaglog, "Please Logout, then Login again.");

                    } else if (ret.status == "InData") {
                        console.log(ret.des);
                    } else if (ret.status == "InExist") {
                        console.log(ret.des);
                        newMsgDiag(MsgDiaglog, ret.des + "make sure you login right.");
                    } else 
                        console.log('listProj: A err. of null of above'); 
                }
            break;
            case 403:
                //callback("Please Login before create item ");
            break;
            case 409:
                //callback("This item already existed");
            break;
            default:
                //console.log("Misc. Err. in creating ", xhr);
                //callback("Misc. Err. in creating ");
        }
      })
      .catch(function (err) {
        newMsgDiag(MsgDiaglog, '** An error occurred during listProj at ' + err);
      });

    }
    
  },

  methods: {

    newProjDiag() {

      // display dialog
      this.carousel = true;

    },

    // select which solution
    newProj() {
      var that = this;      
      
      switch (this.solution) {
        case "quasar":
          // creating quasar dev. env.
          this.$axios({            
            //url: 'dev_env.dev_env.doctype.devenvobj.devenvobj.creQuasar',
            url: 'gnl.gnl.doctype.devenv.devenv.creProj',
            method: 'post',
            baseURL: process.env.BACKEND_PROTO + process.env.BACKEND_DOMAIN + process.env.BACKEND_PORT + '/api/method/',
            data: {
              "user_id": this.$store.state.gen.userInfo.user_id
              , "prj_name": this.projName
              , "soln": this.solution
            },
            headers: { SfAuth: this.$store.state.gen.userInfo.token },
          })
          .then(function (response) {

            switch (response.status) {
                case 200:
                    if (response.data == "{}") {
                        console.log('Creating Qusar: empty response data'); 
                    } else {
                        var ret = JSON.parse(response.data.message);

                        if (ret.status == "Done") {
                            //console.log('ret ', ret);

                            that.carousel = false;

                            // adding new proj.
                            that.$store.commit('gen/addProj', that.projName);

                        } else if (ret.status == "InAuth") {
                            //console.log("ret.des ", ret.des);
                            newMsgDiag(MsgDiaglog, "Please Logout, then Login again.");

                        } else if (ret.status == "InData") {
                            console.log(ret.des);
                        } else if (ret.status == "InExist") {
                            //console.log(ret.des);
                            newMsgDiag(MsgDiaglog, "This Project Name has already existed");
                        } else if (ret.status == "InSoln") {
                            newMsgDiag(MsgDiaglog, "Select a wrong Solution, Please ontact Administrator");
                        } else 
                            console.log('Creating Qusar: A err. of null of above'); 
                    }
                break;
                case 403:
                    //callback("Please Login before create item ");
                break;
                case 409:
                    //callback("This item already existed");
                break;
                default:
                    //console.log("Misc. Err. in creating ", xhr);
                    //callback("Misc. Err. in creating ");
            }
          })
          .catch(function (err) {
            newMsgDiag(MsgDiaglog, '** An error occurred during Creating Qusar at ' + err);

            that.$store.commit('gen/clrProjs');   // clr the projs array to let it reload the list of all projects again. 

          });

          break;
        default:
          console.log("No Right Solution " );
      }
    
    },

    // para.
    //  proj object = {'projName': 'your_proj_name'}
    goSelProj(proj) {
      this.selProj(proj.projName);
    },

    // para.
    //  projName string = 'your_proj_name'
    selProj(projName) {
        
        //==========================================
        // Get this project running state
        var that = this;
        // creating quasar dev. env.
        this.$axios({
          url: 'gnl.gnl.doctype.devenv.devenv.getProjSt',
          method: 'post',
          baseURL: process.env.BACKEND_PROTO + process.env.BACKEND_DOMAIN + process.env.BACKEND_PORT + '/api/method/',
          data: {
            "user_id": this.$store.state.gen.userInfo.user_id
            , "prj_name": projName
            , "soln": this.solution
          },
          headers: { SfAuth: this.$store.state.gen.userInfo.token },
        })
        .then(function (response) {

          //console.log('tokenSignin response ', response);
          switch (response.status) {
              case 200:
                  if (response.data == "{}") {
                      console.log('Creating Qusar: empty response data'); 
                  } else {
                      var ret = JSON.parse(response.data.message);

                      if (ret.status == "Done") {
                        //console.log("ret ", ret);

                        // save teh selected project into global variable
                        that.$store.commit('gen/updateProj', {
                                                                'name':projName
                                                                , "soln": that.solution
                                                                , "sshport": ret.sshport
                                                                , "webport": ret.webport
                                                                , "sshdFolderPort": ret.sshdFolderPort
                                                                } );

                        that.$store.commit('gen/updateSelProjState', ret.state);

                      } else if (ret.status == "InAuth") {
                          newMsgDiag(MsgDiaglog, "Please Logout, then Login again.");

                      } else if (ret.status == "InData") {
                          console.log(ret.des);
                      } else if (ret.status == "InExist") {
                          //console.log(ret.des);
                          newMsgDiag(MsgDiaglog, ret.des + "make sure you login right.");
                      } else 
                          console.log('listProj: A err. of null of above'); 
                  }
              break;
              case 403:
                  //callback("Please Login before create item ");
              break;
              case 409:
                  //callback("This item already existed");
              break;
              default:
                  //console.log("Misc. Err. in creating ", xhr);
                  //callback("Misc. Err. in creating ");
          }
        })
        .catch(function (err) {
          newMsgDiag(MsgDiaglog, '** An error occurred during get Proj status at ' + err);
        });

    },

  },

}
</script>
